<template>
  <li>
    <div class="list-timeline-icon list-timeline-icon-xs" :class="bgColor">
      <XIcon v-if="notification.type == 'error'" />
      <AlertTriangleIcon v-if="notification.type == 'warning'" />
      <CheckIcon v-if="notification.type == 'success'" />
      <InfoCircleIcon v-if="notification.type == 'info'" />
    </div>
    <div class="list-timeline-content list-timeline-content-xs">
      <div class="list-timeline-time">
        <span
          v-b-tooltip.hover.bottom="{ variant: 'dark' }"
          class="date-tooltip date-timeago"
          :title="notification.creation_datetime | formatDate('PP')"
        >
          {{ notification.creation_datetime | timeago }}
        </span>
        <XIcon
          class="list-timeline-icon-xs cursor-pointer"
          @click="removeNotification"
        />
      </div>
      <p class="list-timeline-title time-ago">
        <NuxtLink style="overflow-wrap: normal" :to="notification.url">
          {{ notification.title }}
        </NuxtLink>
      </p>
      <p class="text-muted text-clamp-3 mb-1">
        {{ notification.details }}
      </p>
    </div>
  </li>
</template>

<script>
export default {
  props: {
    notification: {
      type: Object,
      default() {
        return {};
      },
    },
  },
  computed: {
    bgColor() {
      switch (this.notification.type) {
        case 'error':
          return 'bg-red';
        case 'success':
          return 'bg-green';
        case 'warning':
          return 'bg-orange';
        default:
          return 'bg-blue';
      }
    },
  },
  methods: {
    removeNotification() {
      this.$nuxt.context.store.dispatch('notifications/deleteNotification', {
        notificationId: this.notification.id,
      });
    },
  },
};
</script>
